
package net.mcreator.mismods.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.mismods.init.MisModsModItems;
import net.mcreator.mismods.init.MisModsModFluids;
import net.mcreator.mismods.init.MisModsModFluidTypes;
import net.mcreator.mismods.init.MisModsModBlocks;

public abstract class AguavenenosaFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> MisModsModFluidTypes.AGUAVENENOSA_TYPE.get(), () -> MisModsModFluids.AGUAVENENOSA.get(), () -> MisModsModFluids.FLOWING_AGUAVENENOSA.get())
			.explosionResistance(100f).bucket(() -> MisModsModItems.AGUAVENENOSA_BUCKET.get()).block(() -> (LiquidBlock) MisModsModBlocks.AGUAVENENOSA.get());

	private AguavenenosaFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return ParticleTypes.EXPLOSION;
	}

	public static class Source extends AguavenenosaFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends AguavenenosaFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
